/* DreamShell ##version##

   module.c - ffplay hook module example
   Copyright (C)2012 SWAT 

*/
            
#include <kos.h>
#include <kos/exports.h>
#include "libavcodec/avcodec.h"
#include "libavformat/avformat.h"
#include "libswscale/swscale.h"
#include "ds.h"


extern export_sym_t module_symtab[];
static symtab_handler_t st_module = {
	{ "sym/ffplay_hook",
	  0,
	  0x00010000,
	  0,
	  NMMGR_TYPE_SYMTAB,
	  NMMGR_LIST_INIT },
	module_symtab
};

static Event_t *ffplay_hook_video_event = NULL;

const char * lib_get_name() {
      return "ffplay_hook";
}


uint32 lib_get_version() {
       return DS_MAKE_VER(VER_MAJOR, VER_MINOR, VER_MICRO, VER_BUILD);
}


int lib_open(klibrary_t * lib) {
	return nmmgr_handler_add(&st_module.nmmgr);
}


int lib_close(klibrary_t * lib) {
	if(ffplay_hook_video_event)
		RemoveEvent(ffplay_hook_video_event);
    return nmmgr_handler_remove(&st_module.nmmgr); 
}



static void ffplay_draw(void *p, void *p2) {
	//TODO
}

void ffplay_format_handler(AVFormatContext *format, AVCodecContext *video, AVCodecContext *audio) {
	ds_printf("Video: %dx%d %d kbps\n", video->width, video->height, video->bit_rate);
	ds_printf("Audio: %s %d %d kbps\n", audio->channels > 1 ? "stereo" : "mono", audio->sample_rate, audio->bit_rate);
	
	ffplay_hook_video_event = AddEvent("ffplay_hook_video_event", EVENT_TYPE_VIDEO, ffplay_draw, NULL);
}

void ffplay_frame_handler(AVFrame *frame, cont_state_t *state) {
	if (state->buttons & CONT_Y) {
		ds_printf("Pressed Y\n");
	}
}

