/** \file   	cmd_elf.h
 *	\brief  	Definitions for DreamShell elf commands
 *	\date		2004-2011
 *	\author		SWAT
 *	\copyright	http://www.dc-swat.ru
 */


#include <sys/cdefs.h>
#include <arch/types.h>


/* Kernel-specific definition of a loaded ELF binary */
typedef struct cmd_elf_prog {
	void	*data;		/* Data block containing the program */
	uint32	size;		/* Memory image size (rounded up to page size) */

	/* Elf exports */
	ptr_t	main;

} cmd_elf_prog_t;


/* Load an ELF binary and return the relevant data in an cmd_elf_prog_t structure. */
cmd_elf_prog_t *cmd_elf_load(const char *fn);


/* Free a loaded ELF program */
void cmd_elf_free(cmd_elf_prog_t *prog);

