/** 
 *  \file   	events.h
 *	\brief  	Definitions for DreamShell events
 *	\date		2004-2011
 *	\author		SWAT
 *	\copyright	http://www.dc-swat.ru
 */

  
#ifndef _DS_EVENTS_H
#define _DS_EVENTS_H


#include "video.h"

#define EVENT_STATE_ACTIVE 0
#define EVENT_STATE_SLEEP 1

#define EVENT_TYPE_INPUT 0
#define EVENT_TYPE_VIDEO 1


typedef void Event_func(void *, void *);

typedef struct Event {

    const char *name;
    int id;
    Event_func *event;
	void *param;
    int state;
    int type;
       
} Event_t;


int InitEvents();
void ShutdownEvents();

Event_t *AddEvent(const char *name, int type, Event_func *event, void *param);
int RemoveEvent(Event_t *e);

int SetEventState(Event_t *e, int state);


Item_list_t *GetEventList();
Event_t *GetEventById(int id);
Event_t *GetEventByName(const char *name);


void PushEvents(SDL_Event *event, int type);
void PushInputEvents(SDL_Event *event);
void PushVideoEvents();
void ProcessEvents(SDL_Event *event);



#endif
