/** 
 *  \file   	thread.h
 *	\brief  	Definitions for DreamShell threads
 *	\date		2004-2011
 *	\author		SWAT
 *	\copyright	http://www.dc-swat.ru
 */

#ifndef _DS_THREAD_H
#define _DS_THREAD_H

/**
 * Deprecated! Use pthread
 */


//#include "ds.h"
typedef void *ThreadRoutine(void *);


typedef struct Thread {
	
#ifdef DS_ARCH_PSP
    SceUID thd;
#elif DS_ARCH_DC
    kthread_t *thd;
#else
    SDL_Thread *thd;
#endif
    
    const char *name;
    int id;
    
} Thread_t;



int InitThreads();
void ShutdownThreads();

Thread_t *CreateThread(ThreadRoutine *routine, void *param, const char *name);
int DestroyThread(Thread_t *p);
int RemoveThread(Thread_t *p);

int SetThreadPrio(Thread_t *p, int prio);
void WaitThread(Thread_t *p);

Thread_t *GetThreadByName(const char *name);
Thread_t *GetThreadById(int id);
Thread_t *GetCurrentThread();

Item_list_t *GetThreadList(); 




/*
typedef struct Sem {
        
#ifdef DS_ARCH_DC
    semaphore_t *event;
#elif DS_ARCH_PSP
    SceUID event;
#else
    SDL_mutex *event;
#endif
    
} Sem_t;


Sem_t *SemCreate();
int SemDestroy(Sem_t *s);
int SemWait(Sem_t *s);
int SemSignal(Sem_t *s);
*/


#endif
