/** 
 *  \file   	video.h
 *	\brief  	Definitions for DreamShell video rendering
 *	\date		2004-2011
 *	\author		SWAT
 *	\copyright	http://www.dc-swat.ru
 */
     
#ifndef _DS_VIDEO_H
#define _DS_VIDEO_H

#include <kos.h>
//#include "gl/gl.h"
//#include "gl/glu.h"
//#include "gl/kglx.h"
#include "SDL/SDL.h"
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_dreamcast.h"
#include "SDL/SDL_gfxPrimitives.h"
#include "SDL/SDL_gfxBlitFunc.h"
#include "SDL/SDL_rotozoom.h"
#include "SDL/SDL_console.h"
#include "SDL/DT_drawtext.h"
#include "gui.h"

#include "plx/font.h"
#include "plx/sprite.h"
#include "plx/list.h"
#include "plx/dr.h"
#include "plx/context.h"
#include "plx/texture.h"

// Pixel packing macro
#define PACK_PIXEL(r, g, b) ( ((r & 0xF8) << 8) | ((g & 0xFC) << 3) | (b >> 3) )



SDL_Surface *GetScreen();
void SetScreen(SDL_Surface *new_screen);


int GetScreenWidth();
int GetScreenHeight();


void SDL_DS_SetWindow(int width, int height);
void SetScreenMode(int w, int h, float x, float y, float z);

void SDL_DS_AllocScreenTexture(SDL_Surface *screen);
void SDL_DS_FreeScreenTexture(int reset_pvr_memory);

pvr_ptr_t GetScreenTexture();
void SetScreenTexture(pvr_ptr_t *txr);

void SetScreenOpacity(float opacity);
float GetScreenOpacity();
void SetScreenFilter(int filter);
void SetScreenVertex(float u1, float v1, float u2, float v2);

void ScreenRotate(float x, float y, float z);
void ScreenTranslate(float x, float y, float z);

void ScreenFadeIn();
void ScreenFadeOut();

void DisableScreen();
void EnableScreen();
int ScreenIsEnabled();
void ScreenChanged();

void *VideoThread(void *ptr);
void InitVideoThread();
void ShutdownVideoThread();

void LockVideo();
void UnLockVideo();
int VideoIsLocked();

int InitVideo(int w, int h, int bpp);
void ShutdownVideo();


void bf_print(int x, int y, char *str);
void ShowLogo();


/* Load PVR to a KOS Platform Independent Image */
int pvr_to_img(const char *filename, kos_img_t *rv);

/* Load PNG to a KOS Platform Independent Image */
int png_to_img(const char * filename, kos_img_t *rv);


#endif

